__gnu_pbds::detail::tree_traits< Key, null_type, Cmp_Fn, Node_Update, ov_tree_tag, _Alloc > Struct Template Reference
Extensions » Policy-Based Data Structures » Traits

`#include <traits.hpp>`

## Public Types

typedef tree_node_metadata_dispatch< Key, null_type, Cmp_Fn, Node_Update, _Alloc >::type | metadata_type
typedef ov_tree_node_const_it_< value_type, metadata_type, _Alloc > | node_const_iterator
typedef node_const_iterator | node_iterator
typedef Node_Update< node_const_iterator, node_const_iterator, Cmp_Fn, _Alloc > | node_update
typedef __gnu_pbds::null_node_update< node_const_iterator, node_iterator, Cmp_Fn, _Alloc > * | null_node_update_pointer

## Detailed Description

template<typename Key, class Cmp_Fn, template< typename Node_CItr, class Node_Itr, class Cmp_Fn_, typename _Alloc_ > class Node_Update, typename _Alloc>
struct __gnu_pbds::detail::tree_traits< Key, null_type, Cmp_Fn, Node_Update, ov_tree_tag, _Alloc >

Specialization.

Definition at line 132 of file ov_tree_map_/traits.hpp.

## Member Typedef Documentation

## metadata_type

template<typename Key, class Cmp_Fn, template< typename Node_CItr, class Node_Itr, class Cmp_Fn_, typename _Alloc_ > class Node_Update, typename _Alloc>

typedef tree_node_metadata_dispatch<Key,null_type,Cmp_Fn,Node_Update,_Alloc>::type __gnu_pbds::detail::tree_traits< Key, null_type, Cmp_Fn, Node_Update, ov_tree_tag, _Alloc >::metadata_type

Definition at line 157 of file ov_tree_map_/traits.hpp.

## node_const_iterator

template<typename Key, class Cmp_Fn, template< typename Node_CItr, class Node_Itr, class Cmp_Fn_, typename _Alloc_ > class Node_Update, typename _Alloc>

typedef ov_tree_node_const_it_< value_type, metadata_type, _Alloc> __gnu_pbds::detail::tree_traits< Key, null_type, Cmp_Fn, Node_Update, ov_tree_tag, _Alloc >::node_const_iterator

This is an iterator to an iterator: it iterates over nodes, and de-referencing it returns one of the tree's iterators.

Definition at line 166 of file ov_tree_map_/traits.hpp.

## node_iterator

template<typename Key, class Cmp_Fn, template< typename Node_CItr, class Node_Itr, class Cmp_Fn_, typename _Alloc_ > class Node_Update, typename _Alloc>

typedef node_const_iterator __gnu_pbds::detail::tree_traits< Key, null_type, Cmp_Fn, Node_Update, ov_tree_tag, _Alloc >::node_iterator

Definition at line 168 of file ov_tree_map_/traits.hpp.

## node_update

template<typename Key, class Cmp_Fn, template< typename Node_CItr, class Node_Itr, class Cmp_Fn_, typename _Alloc_ > class Node_Update, typename _Alloc>

typedef Node_Update< node_const_iterator, node_const_iterator, Cmp_Fn, _Alloc> __gnu_pbds::detail::tree_traits< Key, null_type, Cmp_Fn, Node_Update, ov_tree_tag, _Alloc >::node_update

Definition at line 176 of file ov_tree_map_/traits.hpp.

## null_node_update_pointer

template<typename Key, class Cmp_Fn, template< typename Node_CItr, class Node_Itr, class Cmp_Fn_, typename _Alloc_ > class Node_Update, typename _Alloc>

typedef __gnu_pbds::null_node_update< node_const_iterator, node_iterator, Cmp_Fn, _Alloc>* __gnu_pbds::detail::tree_traits< Key, null_type, Cmp_Fn, Node_Update, ov_tree_tag, _Alloc >::null_node_update_pointer

Definition at line 184 of file ov_tree_map_/traits.hpp.

The documentation for this struct was generated from the following file:

- ov_tree_map_/traits.hpp